function oMat = filt2mat(filt, patch_size)
% Extend input kernel to image-size matrix 

    %Initials
    imsize = patch_size;
    patch_sizer = size(filt,1); patch_sizec = size(filt,2);

    % Build indices
    row_inds = repmat((1:patch_sizer)',1,patch_sizec);
    col_inds = repmat(1:patch_sizec,patch_sizer,1);
    inds = sub2ind(patch_size, row_inds, col_inds);
    
    % ???
    w_offsets = reshape(1:prod(imsize),imsize);
    w_offsets = w_offsets(1:end-size(filt,1)+1,1:end-size(filt,2)+1);
    w_offsets = reshape(w_offsets,[],1);

    %???
    filt_size = size(filt,1)*size(filt,2);
    row_inds = repmat((1:length(w_offsets))', filt_size,1);
    col_inds = reshape(repmat(w_offsets,1,filt_size)-1 + repmat(reshape(inds,1,[]),length(w_offsets),1),[],1);
    vals = reshape(repmat(reshape(filt,1,[]),length(w_offsets),1),[],1);
    
    % Return convolution matris for the input kernel
    oMat = sparse(row_inds, col_inds, vals);
    
end
